<?php
// $Id: handler_field_duration.inc,v 1.1.2.2 2010/09/25 11:26:22 drunkenmonkey Exp $

/**
 * Views field handler class for treating durations.
 */
class SearchApiViewsHandlerFieldDuration extends SearchApiViewsHandlerField {

  /**
   * Specifies the options this handler uses.
   */
  function option_definition() {
    $options = parent::option_definition();
    $options['format_interval'] = array('default' => TRUE);
    return $options;
  }

  /**
   * Returns an option form for setting this handler's options.
   */
  function options_form(array &$form, array &$form_state) {
    parent::options_form($form, $form_state);

    $form['format_interval'] = array(
      '#title' => t('Format as interval'),
      '#type' => 'checkbox',
      '#default_value' => $this->options['format_interval'],
      '#weight' => -5,
    );
  }

  /**
   * Helper function for rendering a single value.
   */
  protected function renderValue($value) {
    if ($this->options['format_interval']) {
      return format_interval($value);
    }
    return check_plain($value);
  }

}
